from ..._common.config import *
from ..._common.const import *
from ..._utils import _validate_args, get


__all__ = ['dataitems', 'packages', 'functions']


@_validate_args
def dataitems(search: str = None, package: str = None):
    param = {'search': search, 'package': package}
    return get(URL_DATAITEMS, param)


def packages():
    return get(URL_PACKAGES, None)


def functions():
    return get(URL_FUNCTIONS, None)


# list functions
@_validate_args
def _list_dataitem_financial(datacomponent: str = None, search: str = None, package: str = None):
    param = {'datacategory': 'Financial', 'datacomponent': datacomponent, 'search': search, 'package': package}
    return get(URL_DATAITEMS, param)


@_validate_args
def _list_dataitem_estimate(datacomponent, search: str = None, package: str = None):
    param = {'datacategory': 'Estimate', 'datacomponent': datacomponent, 'search': search, 'package': package}
    return get(URL_DATAITEMS, param)


@_validate_args
def _list_dataitem_market(datacomponent: str, search: str = None, package: str = None):
    param = {'datacategory': 'Market', 'datacomponent': datacomponent, 'search': search, 'package': package}
    return get(URL_DATAITEMS, param)


@_validate_args
def _list_dataitem_precalculated(datacomponent: str, search: str = None, package: str = None):
    param = {'datacategory': 'Precalculated', 'datacomponent': datacomponent, 'search': search, 'package': package}
    return get(URL_DATAITEMS, param)


@_validate_args
def _list_dataitem_index(datacomponent: str, search: str = None, package: str = None):
    param = {
        'datacategory': 'Index',
        'datacomponent': datacomponent,
        'search': search,
        'package': package
    }
    return get(URL_DATAITEMS, param)


@_validate_args
def _list_dataitem_event(datacomponent: str = None, search: str = None, package: str = None):
    param = {'datacategory': 'Event', 'datacomponent': datacomponent, 'search': search, 'package': package}
    return get(URL_DATAITEMS, param)


@_validate_args
def _list_dataitem_industry(datacomponent: str = None, search: str = None, package: str = None):
    param = {'datacategory': 'Industry', 'datacomponent': datacomponent, 'search': search, 'package': package}
    return get(URL_DATAITEMS, param)