from prism._utils.exceptions import PrismValueError
from ..._common.config import *
from ..._common.const import *
from ..._utils import _validate_args, post
from ..._utils.validate_utils import get_sm_attributevalue


__all__ = ['get_securitymaster', 'get_securitymaster_advanced']


@_validate_args
def get_securitymaster(attribute: str, search: str):
    attributevalue = get_sm_attributevalue(attribute)
    query = [{'attribute': attributevalue, 'search': search}]
    return post(URL_SM, None, query)


@_validate_args
def get_securitymaster_advanced(queries: list):
    if len(queries) == 0: raise PrismValueError('At least one query must be provided.')
    for i in range(len(queries)):
        assert isinstance(queries, dict), 'queries must be list of dicts.'
        assert set(queries[i].keys()) - {'operator'} == {'attribute', 'search'}, \
            'Valid arguments are "attribute", "search", and "operator".'
        queries[i]['attribute'] = get_sm_attributevalue(queries[i]['attribute'])

    return post(URL_SM, None, queries)
