import os
import errno
import sys
import requests
import uuid

from prism._utils.exceptions import PrismAuthError

from .._common.config import URL_WEB_AUTH, HEADERS

def _authentication():
    try:
        headers = HEADERS.copy()
        if 'auth_token' not in globals():
            raise PrismAuthError(f"Please Login First")
        token = auth_token
        headers.update({"Authorization": "Bearer {}".format(token)})
        req_id = str(uuid.uuid4())[:8]
        headers.update({"requestid": req_id})
    except FileNotFoundError:
        raise PrismAuthError(f"Please Login First")
    return headers


def _delete_token():
    global auth_token
    auth_token = ''


def _create_token(response: requests.models.Response, username: str):
    global auth_token
    token = response.json()["access_token"]
    auth_token = token
    return


def _find_file_path(file_name: str):
    sys.path.append(os.getcwd())
    for path in sys.path:
        if os.path.exists(path + "/" + file_name):
            return path + "/" + file_name
    raise FileNotFoundError(errno.ENOENT, os.strerror(errno.ENOENT), file_name)


class TokenDoesNotExistError(Exception):
    def __init__(self):
        super().__init__("You should first login to create a token")


def _get_web_authentication_token():
    headers = _authentication()
    res = requests.post(URL_WEB_AUTH, headers=headers)
    web_auth_token = res.json().get("access_token")
    return web_auth_token
